Index: branches/MESI/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/MESI/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 719)
+++ branches/MESI/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 785)
@@ -351,5 +351,4 @@
             const IntTab        &srcid_x,          // global index on external network
             const IntTab        &tgtid_d,          // global index on direct network
-            const size_t        cc_global_id,      // global index on cc network
             const size_t        x_width,           // number of x bits in platform
             const size_t        y_width,           // number of x bits in platform
@@ -384,7 +383,6 @@
         m_sets( nsets ),
         m_words( nwords ),
-        m_cc_global_id( cc_global_id ),
-        m_xwidth(x_width),
-        m_ywidth(y_width),
+        m_x_width(x_width),
+        m_y_width(y_width),
         m_debug_start_cycle( debug_start_cycle ),
         m_debug_ok( debug_ok ),
@@ -550,8 +548,12 @@
             for(seg = m_seglist.begin() ; seg != m_seglist.end() ; seg++)
             {
-                if ( seg->special() ) m_seg_config = i;
+                if (seg->special() ) m_seg_config = i;
                 m_seg[i] = & (*seg);
                 i++;
             }
+
+            addr_t gid = m_seg[0]->baseAddress() >> (vci_param_int::N - x_width - y_width);
+            m_x_self = (gid >> m_y_width) & ((1 << m_x_width) - 1);
+            m_y_self =  gid               & ((1 << m_y_width) - 1);
 
             // Allocation for IXR_RSP FSM
@@ -614,10 +616,10 @@
         bool data_change = false;
 
-        if ( entry.state != ENTRY_INVALID )
+        if (entry.state != ENTRY_INVALID )
         {
             for ( size_t word = 0 ; word<m_words ; word++ )
             {
                 m_debug_data[word] = m_cache_data.read(way, set, word);
-                if ( (m_debug_previous_valid != ENTRY_INVALID) and 
+                if ((m_debug_previous_valid != ENTRY_INVALID) and 
                         (m_debug_data[word] != m_debug_previous_data[word]) )
                 {
@@ -628,5 +630,5 @@
 
         // print values if any change
-        if ( (entry.state != m_debug_previous_valid) or
+        if ((entry.state != m_debug_previous_valid) or
                 ((entry.state != ENTRY_INVALID) and (entry.count != m_debug_previous_count)) or
                 ((entry.state != ENTRY_INVALID) and (entry.dirty != m_debug_previous_dirty)) or data_change )
@@ -672,10 +674,9 @@
     {
         const uint32_t srcid_width = vci_param_int::S;
-        uint8_t self_x_srcid = m_cc_global_id >> (srcid_width - m_xwidth);
-        uint8_t self_y_srcid = (m_cc_global_id >> (srcid_width - m_ywidth)) & ((1 << m_xwidth) - 1);
-
-        uint8_t x_srcid = req_srcid >> (srcid_width - m_xwidth);
-        uint8_t y_srcid = (req_srcid >> (srcid_width - m_ywidth - m_xwidth)) & ((1 << m_xwidth) - 1);
-        return abs(self_x_srcid - x_srcid) + abs(self_y_srcid - y_srcid);
+
+        uint8_t req_x = (req_srcid >> (srcid_width - m_x_width));
+        uint8_t req_y = (req_srcid >> (srcid_width - m_x_width - m_y_width)) & ((1 << m_y_width) - 1);
+
+        return abs(m_x_self - req_x) + abs(m_y_self - req_y);
     }
 
@@ -706,5 +707,5 @@
             // LOCAL
 
-            case MEMC_LOCAL_READ_LO   : rdata = m_cpt_read_miss_local   ; break;
+            case MEMC_LOCAL_READ_LO   : rdata = m_cpt_read_local   ; break;
             case MEMC_LOCAL_WRITE_LO  : rdata = m_cpt_write_flits_local ; break;
             case MEMC_LOCAL_LL_LO     : rdata = m_cpt_ll_local          ; break;
@@ -719,5 +720,5 @@
             // REMOTE
 
-            case MEMC_REMOTE_READ_LO  : rdata = m_cpt_read_miss_remote   ; break;
+            case MEMC_REMOTE_READ_LO  : rdata = m_cpt_read_remote   ; break;
             case MEMC_REMOTE_WRITE_LO : rdata = m_cpt_write_flits_remote ; break;
             case MEMC_REMOTE_LL_LO    : rdata = m_cpt_ll_remote          ; break;
@@ -732,5 +733,5 @@
             // COST
 
-            case MEMC_COST_READ_LO    : rdata = m_cpt_read_miss_cost ; break;
+            case MEMC_COST_READ_LO    : rdata = m_cpt_read_cost ; break;
             case MEMC_COST_WRITE_LO   : rdata = m_cpt_write_cost; break;
             case MEMC_COST_LL_LO      : rdata = m_cpt_ll_cost   ; break;
@@ -753,7 +754,7 @@
             // LOCAL
 
-            case MEMC_LOCAL_MUPDATE_LO  : rdata = m_cpt_update_local ; break;
-            case MEMC_LOCAL_MINVAL_LO   : rdata = m_cpt_minval_local ; break;
-            case MEMC_LOCAL_CLEANUP_LO  : rdata = m_cpt_cleanup_local; break;
+            case MEMC_LOCAL_MUPDATE_LO  : rdata = m_cpt_inval_ro_local; break;
+            case MEMC_LOCAL_MINVAL_LO   : rdata = m_cpt_minval_local ;  break;
+            case MEMC_LOCAL_CLEANUP_LO  : rdata = m_cpt_cleanup_local;  break;
             case MEMC_LOCAL_MUPDATE_HI  :
             case MEMC_LOCAL_MINVAL_HI   :
@@ -762,7 +763,7 @@
             // REMOTE
 
-            case MEMC_REMOTE_MUPDATE_LO : rdata = m_cpt_update_remote ; break;
-            case MEMC_REMOTE_MINVAL_LO  : rdata = m_cpt_minval_remote ; break;
-            case MEMC_REMOTE_CLEANUP_LO : rdata = m_cpt_cleanup_remote; break;
+            case MEMC_REMOTE_MUPDATE_LO : rdata = m_cpt_inval_ro_remote; break;
+            case MEMC_REMOTE_MINVAL_LO  : rdata = m_cpt_minval_remote ;  break;
+            case MEMC_REMOTE_CLEANUP_LO : rdata = m_cpt_cleanup_remote;  break;
             case MEMC_REMOTE_MUPDATE_HI :
             case MEMC_REMOTE_MINVAL_HI  :
@@ -771,7 +772,7 @@
             // COST
 
-            case MEMC_COST_MUPDATE_LO   : rdata = m_cpt_update_cost   ; break;
-            case MEMC_COST_MINVAL_LO    : rdata = m_cpt_minval_cost   ; break;
-            case MEMC_COST_CLEANUP_LO   : rdata = m_cpt_cleanup_cost  ; break;
+            case MEMC_COST_MUPDATE_LO   : rdata = m_cpt_inval_ro_cost; break;
+            case MEMC_COST_MINVAL_LO    : rdata = m_cpt_minval_cost;   break;
+            case MEMC_COST_CLEANUP_LO   : rdata = m_cpt_cleanup_cost;  break;
             case MEMC_COST_MUPDATE_HI   :
             case MEMC_COST_MINVAL_HI    :
@@ -779,8 +780,8 @@
 
             // TOTAL
-
-            case MEMC_TOTAL_MUPDATE_LO  : rdata = m_cpt_update ; break;
-            case MEMC_TOTAL_MINVAL_LO   : rdata = m_cpt_minval ; break;
-            case MEMC_TOTAL_BINVAL_LO   : rdata = m_cpt_binval ; break;
+            // inval_ro are equal to the number of requests triggering them
+            case MEMC_TOTAL_MUPDATE_LO  : rdata = m_cpt_inval_ro_local + m_cpt_inval_ro_remote; break;
+            case MEMC_TOTAL_MINVAL_LO   : rdata = m_cpt_minval ;  break;
+            case MEMC_TOTAL_BINVAL_LO   : rdata = m_cpt_binval ;  break;
             case MEMC_TOTAL_MUPDATE_HI  :
             case MEMC_TOTAL_MINVAL_HI   :
@@ -788,5 +789,4 @@
 
             // unknown register
-
             default                     : error = 1;
         }
@@ -819,5 +819,5 @@
             << " | " << alloc_heap_fsm_str[r_alloc_heap_fsm.read()] << std::endl;
 
-        if ( detailed ) m_trt.print(0);
+        if (detailed ) m_trt.print(0);
     }
 
@@ -827,158 +827,69 @@
     /////////////////////////////////////////
     {
-        m_cpt_reset_count        = m_cpt_cycles;
-
-        m_cpt_read_miss_local           = 0 ; 
-        m_cpt_read_miss_remote          = 0 ; 
-        m_cpt_read_miss_cost            = 0 ;     
-                                                                                 
-        m_cpt_getm_miss_local           = 0 ;     
-        m_cpt_getm_miss_remote          = 0 ;     
-                                                                                         
-        m_cpt_getm_hit_local            = 0 ;     
-        m_cpt_getm_hit_remote           = 0 ;         
-        m_cpt_getm_cost                 = 0 ; 
-                                                                                             
-        m_cpt_write_local               = 0 ;     
-        m_cpt_write_remote              = 0 ;     
-        m_cpt_write_flits_local         = 0 ;         
-        m_cpt_write_flits_remote        = 0 ;         
-        m_cpt_write_cost                = 0 ;    
-
-        m_cpt_ll_local                  = 0 ;         
-        m_cpt_ll_remote                 = 0 ;             
-        m_cpt_ll_cost                   = 0 ;         
-                                                                                            
-        m_cpt_sc_local                  = 0 ;                             
-        m_cpt_sc_remote                 = 0 ;                             
-        m_cpt_sc_cost                   = 0 ;                             
-                                                                                         
-        m_cpt_cas_local                 = 0 ;                                 
-        m_cpt_cas_remote                = 0 ;                                     
-        m_cpt_cas_cost                  = 0 ;                                 
-                                                                                     
-        m_cpt_update                    = 0 ;                     
-        m_cpt_update_local              = 0 ;                             
-        m_cpt_update_remote             = 0 ;                             
-        m_cpt_update_cost               = 0 ;                         
-                                                                                    
-        m_cpt_minval                    = 0 ;                 
-        m_cpt_minval_local              = 0 ;                         
-        m_cpt_minval_remote             = 0 ;                     
-        m_cpt_minval_cost               = 0 ;                         
-                                                                                     
-        m_cpt_binval                    = 0 ;                     
-                                                                                             
-        m_cpt_cleanup_local             = 0 ;                             
-        m_cpt_cleanup_remote            = 0 ;                         
-        m_cpt_cleanup_with_data         = 0 ;                             
-        m_cpt_cleanup_cost              = 0 ;                         
-                                                                                     
-        m_cpt_multi_ack_miss            = 0 ;                         
-        m_cpt_multi_ack_hit             = 0 ;                     
-        m_cpt_multi_ack_hit_with_data   = 0 ;                             
-                                                                                     
-                                                 
-        m_cpt_read_miss                 = 0 ;                                     
-        m_cpt_getm_miss                 = 0 ;                                 
-        m_cpt_getm_broadcast            = 0 ;                                     
-        m_cpt_getm_minval               = 0 ;                                     
-        m_cpt_write_miss                = 0 ;                                             
-        m_cpt_write_dirty               = 0 ;                                             
-        m_cpt_write_broadcast           = 0 ;                                                 
-        m_cpt_write_minval              = 0 ;                                         
-        m_cpt_cas_broadcast             = 0 ;                                                 
-        m_cpt_cas_minval                = 0 ;                                                                 
-        m_cpt_cas_miss                  = 0 ;                                                 
-                                                                                     
-        m_cpt_read_locked_rb            = 0 ;                                                                 
-        m_cpt_cas_locked_rb             = 0 ;                                                                 
-        m_cpt_write_locked_rb           = 0 ;                                                                                             
-                                                                                     
-        m_cpt_trt_rb                    = 0 ;                                                                 
-        m_cpt_trt_full                  = 0 ;                                                             
-        m_cpt_put                       = 0 ;                                                             
-        m_cpt_get                       = 0 ;                                                             
-        m_cpt_read_fsm_dir_lock         = 0 ;                                                                         
-        m_cpt_read_fsm_n_dir_lock       = 0 ;                                                                         
-        m_cpt_write_fsm_dir_lock        = 0 ;                                                                 
-        m_cpt_write_fsm_n_dir_lock      = 0 ;                                                                                         
-        m_cpt_xram_rsp_fsm_dir_lock     = 0 ;                                                                             
-        m_cpt_xram_rsp_fsm_n_dir_lock   = 0 ;                                                                 
-        m_cpt_cas_fsm_dir_lock          = 0 ;                                                         
-        m_cpt_cas_fsm_n_dir_lock        = 0 ;                                             
-        m_cpt_cleanup_fsm_dir_lock      = 0 ;                                                         
-        m_cpt_cleanup_fsm_n_dir_lock    = 0 ;                                                     
-        m_cpt_multi_ack_fsm_dir_lock    = 0 ;                                                 
-        m_cpt_multi_ack_fsm_n_dir_lock  = 0 ;                                                     
-                                                                                        
-        m_cpt_dir_unused                = 0 ;                                                             
-        m_cpt_read_fsm_dir_used         = 0 ;                                                             
-        m_cpt_write_fsm_dir_used        = 0 ;                                                     
-        m_cpt_cas_fsm_dir_used          = 0 ;                                             
-        m_cpt_xram_rsp_fsm_dir_used     = 0 ;                                                 
-        m_cpt_cleanup_fsm_dir_used      = 0 ;                                                 
-        m_cpt_multi_ack_fsm_dir_used    = 0 ;                                                         
-                                                                                                                    
-        m_cpt_read_fsm_trt_lock         = 0 ;                                                 
-        m_cpt_write_fsm_trt_lock        = 0 ;                                                         
-        m_cpt_cas_fsm_trt_lock          = 0 ;                                                         
-        m_cpt_xram_rsp_fsm_trt_lock     = 0 ;                                                     
-        m_cpt_ixr_fsm_trt_lock          = 0 ;                                                     
-                                                                                     
-        m_cpt_read_fsm_n_trt_lock       = 0 ;                                             
-        m_cpt_write_fsm_n_trt_lock      = 0 ;                                                         
-        m_cpt_cas_fsm_n_trt_lock        = 0 ;                                                     
-        m_cpt_xram_rsp_fsm_n_trt_lock   = 0 ;                                         
-        m_cpt_ixr_cmd_fsm_n_trt_lock    = 0 ;                                                             
-        m_cpt_ixr_rsp_fsm_n_trt_lock    = 0 ;                                                     
-                                                                                     
-        m_cpt_read_fsm_trt_used         = 0 ;                                                     
-        m_cpt_write_fsm_trt_used        = 0 ;                                                         
-        m_cpt_cas_fsm_trt_used          = 0 ;                                             
-        m_cpt_xram_rsp_fsm_trt_used     = 0 ;                                                     
-        m_cpt_ixr_cmd_fsm_trt_used      = 0 ;                                                 
-        m_cpt_ixr_rsp_fsm_trt_used      = 0 ;                                                     
-        m_cpt_cleanup_fsm_trt_used      = 0 ;                                             
-                                                                                                             
-        m_cpt_trt_unused                = 0 ;                                                 
-                                                                                    
-        m_cpt_cleanup_fsm_ivt_lock      = 0 ;                                             
-        m_cpt_cleanup_fsm_n_ivt_lock    = 0 ;                                                         
-                                                                                     
-        m_cpt_multi_ack_fsm_ivt_lock    = 0 ;                                                 
-        m_cpt_multi_ack_fsm_n_ivt_lock  = 0 ;                                             
-                                                                                    
-        m_cpt_ivt_unused                = 0 ;                             
-                                                                                     
-        m_cpt_read_fsm_heap_lock        = 0 ;                                                     
-        m_cpt_write_fsm_heap_lock       = 0 ;                                                 
-        m_cpt_cas_fsm_heap_lock         = 0 ;                                             
-        m_cpt_cleanup_fsm_heap_lock     = 0 ;                                                         
-        m_cpt_xram_rsp_fsm_heap_lock    = 0 ;                                                             
-        m_cpt_multi_ack_fsm_heap_lock   = 0 ;                                                 
-                                                                                    
-        m_cpt_read_fsm_n_heap_lock      = 0 ;                                                 
-        m_cpt_write_fsm_n_heap_lock     = 0 ;                                             
-        m_cpt_cas_fsm_n_heap_lock       = 0 ;                                                     
-        m_cpt_cleanup_fsm_n_heap_lock   = 0 ;                                                     
-        m_cpt_xram_rsp_fsm_n_heap_lock  = 0 ;                                                         
-        m_cpt_multi_ack_fsm_n_heap_lock = 0 ;                                                         
-                                                                                                                 
-        m_cpt_read_fsm_heap_used        = 0 ;                                                 
-        m_cpt_write_fsm_heap_used       = 0 ;                                                 
-        m_cpt_cas_fsm_heap_used         = 0 ;                                             
-        m_cpt_cleanup_fsm_heap_used     = 0 ;                                         
-        m_cpt_xram_rsp_fsm_heap_used    = 0 ;                                         
-        m_cpt_multi_ack_fsm_heap_used   = 0 ;                                                     
-                                                                                     
-        m_cpt_heap_unused               = 0 ;                     
-        m_cpt_slot_inval                = 0 ;
-    
+        m_cpt_reset_count               = m_cpt_cycles;
+
+        m_cpt_read_local                = 0;
+        m_cpt_read_remote               = 0;
+        m_cpt_read_cost                 = 0;
+
+        m_cpt_write_local               = 0;
+        m_cpt_write_remote              = 0;
+        m_cpt_write_flits_local         = 0;
+        m_cpt_write_flits_remote        = 0;
+        m_cpt_write_cost                = 0;
+
+        m_cpt_ll_local                  = 0;
+        m_cpt_ll_remote                 = 0;
+        m_cpt_ll_cost                   = 0;
+
+        m_cpt_sc_local                  = 0;
+        m_cpt_sc_remote                 = 0;
+        m_cpt_sc_cost                   = 0;
+
+        m_cpt_cas_local                 = 0;
+        m_cpt_cas_remote                = 0;
+        m_cpt_cas_cost                  = 0;
+
+        m_cpt_minval                    = 0;
+        m_cpt_minval_local              = 0;
+        m_cpt_minval_remote             = 0;
+        m_cpt_minval_cost               = 0;
+
+        m_cpt_binval                    = 0;
+        m_cpt_write_broadcast           = 0;
+        m_cpt_getm_broadcast            = 0;
+
+        m_cpt_cleanup_local             = 0;
+        m_cpt_cleanup_remote            = 0;
+        m_cpt_cleanup_cost              = 0;
+        m_cpt_cleanup_data_local        = 0;
+        m_cpt_cleanup_data_remote       = 0;
+        m_cpt_cleanup_data_cost         = 0;
+
+        m_cpt_read_miss                 = 0;
+        m_cpt_write_miss                = 0;
+        m_cpt_write_dirty               = 0;
+        m_cpt_getm_miss                 = 0;
+
+        m_cpt_getm_local                = 0;
+        m_cpt_getm_remote               = 0;
+        m_cpt_getm_cost                 = 0;
+
+        m_cpt_inval_ro_local            = 0;
+        m_cpt_inval_ro_remote           = 0;
+        m_cpt_inval_ro_cost             = 0; 
+
+        m_cpt_trt_rb                    = 0;
+        m_cpt_trt_full                  = 0;
+        m_cpt_put                       = 0;
+        m_cpt_get                       = 0;
+
+        m_cpt_heap_unused               = 0;
+        m_cpt_slot_inval                = 0;
     }
 
 
     /////////////////////////////////////////
-    tmpl(void)::print_stats(bool activity_counters = true, bool stats = true)
+    tmpl(void)::print_stats(bool activity_counters)
     {
         std::cout << "**********************************" << std::dec << std::endl;
@@ -993,53 +904,72 @@
                 << "[001] NUMBER OF CYCLES          = " << m_cpt_cycles << std::endl
                 << std::endl
-                << "[002] LOCAL READ                = " << m_cpt_read_miss_local << std::endl
-                << "[003] REMOTE READ               = " << m_cpt_read_miss_remote << std::endl
-                << "[004] READ COST (FLITS * DIST)  = " << m_cpt_read_miss_cost << std::endl
+                << "[010] LOCAL READ                = " << m_cpt_read_local << std::endl
+                << "[011] REMOTE READ               = " << m_cpt_read_remote << std::endl
+                << "[012] READ COST (FLITS * DIST)  = " << m_cpt_read_cost << std::endl
                 << std::endl
-                << "[005] LOCAL WRITE               = " << m_cpt_write_local << std::endl
-                << "[006] REMOTE WRITE              = " << m_cpt_write_remote << std::endl
-                << "[007] WRITE FLITS LOCAL         = " << m_cpt_write_flits_local << std::endl
-                << "[008] WRITE FLITS REMOTE        = " << m_cpt_write_flits_remote << std::endl
-                << "[009] WRITE COST (FLITS * DIST) = " << m_cpt_write_cost << std::endl
+                << "[020] LOCAL WRITE               = " << m_cpt_write_local << std::endl
+                << "[021] REMOTE WRITE              = " << m_cpt_write_remote << std::endl
+                << "[022] WRITE FLITS LOCAL         = " << m_cpt_write_flits_local << std::endl
+                << "[023] WRITE FLITS REMOTE        = " << m_cpt_write_flits_remote << std::endl
+                << "[024] WRITE COST (FLITS * DIST) = " << m_cpt_write_cost << std::endl
+                << "[025] WRITE L1 MISS NCC         = " << "0" << std::endl
                 << std::endl
-                << "[010] LOCAL LL                  = " << m_cpt_ll_local << std::endl
-                << "[011] REMOTE LL                 = " << m_cpt_ll_remote << std::endl
-                << "[012] LL COST (FLITS * DIST)    = " << m_cpt_ll_cost << std::endl
+                << "[030] LOCAL LL                  = " << m_cpt_ll_local << std::endl
+                << "[031] REMOTE LL                 = " << m_cpt_ll_remote << std::endl
+                << "[032] LL COST (FLITS * DIST)    = " << m_cpt_ll_cost << std::endl
                 << std::endl
-                << "[013] LOCAL SC                  = " << m_cpt_sc_local << std::endl
-                << "[014] REMOTE SC                 = " << m_cpt_sc_remote << std::endl
-                << "[015] SC COST (FLITS * DIST)    = " << m_cpt_sc_cost << std::endl
+                << "[040] LOCAL SC                  = " << m_cpt_sc_local << std::endl
+                << "[041] REMOTE SC                 = " << m_cpt_sc_remote << std::endl
+                << "[042] SC COST (FLITS * DIST)    = " << m_cpt_sc_cost << std::endl
                 << std::endl
-                << "[016] LOCAL CAS                 = " << m_cpt_cas_local << std::endl
-                << "[017] REMOTE CAS                = " << m_cpt_cas_remote << std::endl
-                << "[018] CAS COST (FLITS * DIST)   = " << m_cpt_cas_cost << std::endl
+                << "[050] LOCAL CAS                 = " << m_cpt_cas_local << std::endl
+                << "[051] REMOTE CAS                = " << m_cpt_cas_remote << std::endl
+                << "[052] CAS COST (FLITS * DIST)   = " << m_cpt_cas_cost << std::endl
                 << std::endl
-                << "[019] REQUESTS TRIG. UPDATE     = " << m_cpt_update << std::endl
-                << "[020] LOCAL UPDATE              = " << m_cpt_update_local << std::endl
-                << "[021] REMOTE UPDATE             = " << m_cpt_update_remote << std::endl
-                << "[022] UPDT COST (FLITS * DIST)  = " << m_cpt_update_cost << std::endl
+                << "[060] REQUESTS TRIG. UPDATE     = " << "0" << std::endl
+                << "[061] LOCAL UPDATE              = " << "0" << std::endl
+                << "[062] REMOTE UPDATE             = " << "0" << std::endl
+                << "[063] UPDT COST (FLITS * DIST)  = " << "0" << std::endl
                 << std::endl
-                << "[023] REQUESTS TRIG. M_INV      = " << m_cpt_minval << std::endl
-                << "[024] LOCAL M_INV               = " << m_cpt_minval_local << std::endl
-                << "[025] REMOTE M_INV              = " << m_cpt_minval_remote << std::endl
-                << "[026] M_INV COST (FLITS * DIST) = " << m_cpt_minval_cost << std::endl
+                << "[070] REQUESTS TRIG. M_INV      = " << m_cpt_minval << std::endl
+                << "[071] LOCAL M_INV               = " << m_cpt_minval_local << std::endl
+                << "[072] REMOTE M_INV              = " << m_cpt_minval_remote << std::endl
+                << "[073] M_INV COST (FLITS * DIST) = " << m_cpt_minval_cost << std::endl
                 << std::endl
-                << "[027] BROADCAT INVAL            = " << m_cpt_binval << std::endl
+                << "[080] BROADCAT INVAL            = " << m_cpt_binval << std::endl
+                << "[081] WRITE BROADCAST           = " << m_cpt_write_broadcast << std::endl
+                << "[082] GETM BROADCAST            = " << m_cpt_getm_broadcast << std::endl
                 << std::endl
-                << "[028] LOCAL CLEANUP             = " << m_cpt_cleanup_local << std::endl
-                << "[029] REMOTE CLEANUP            = " << m_cpt_cleanup_remote << std::endl
-                << "[030] CLNUP COST (FLITS * DIST) = " << m_cpt_cleanup_cost << std::endl
+                << "[090] LOCAL CLEANUP             = " << m_cpt_cleanup_local << std::endl
+                << "[091] REMOTE CLEANUP            = " << m_cpt_cleanup_remote << std::endl
+                << "[092] CLNUP COST (FLITS * DIST) = " << m_cpt_cleanup_cost << std::endl
+                << "[093] LOCAL CLEANUP DATA        = " << m_cpt_cleanup_data_local << std::endl
+                << "[094] REMOTE CLEANUP DATA       = " << m_cpt_cleanup_data_remote << std::endl
+                << "[095] CLEANUP DATA COST         = " << m_cpt_cleanup_data_cost << std::endl
                 << std::endl
+                << "[100] READ MISS                 = " << m_cpt_read_miss << std::endl
+                << "[101] WRITE MISS                = " << m_cpt_write_miss << std::endl
+                << "[102] WRITE DIRTY               = " << m_cpt_write_dirty << std::endl
+                << "[103] GETM MISS                 = " << m_cpt_getm_miss << std::endl
                 << std::endl
-                << "[031] READ MISS                 = " << m_cpt_read_miss << std::endl
-                << "[032] WRITE MISS                = " << m_cpt_write_miss << std::endl
-                << "[033] WRITE DIRTY               = " << m_cpt_write_dirty << std::endl
-                << "[034] RD BLOCKED BY HIT IN TRT  = " << m_cpt_trt_rb << std::endl
-                << "[035] TRANS BLOCKED BY FULL TRT = " << m_cpt_trt_full << std::endl
-                << "[036] PUT (UNIMPLEMENTED)       = " << m_cpt_put << std::endl
-                << "[037] GET (UNIMPLEMENTED)       = " << m_cpt_get << std::endl
-                << "[038] WRITE BROADCAST           = " << m_cpt_write_broadcast << std::endl
+                << "[110] RD BLOCKED BY HIT IN TRT  = " << m_cpt_trt_rb << std::endl
+                << "[111] TRANS BLOCKED BY FULL TRT = " << m_cpt_trt_full << std::endl
+                << "[120] PUT (UNIMPLEMENTED)       = " << m_cpt_put << std::endl
+                << "[121] GET (UNIMPLEMENTED)       = " << m_cpt_get << std::endl
+                << "[130] MIN HEAP SLOT AVAILABLE   = " << "-1" << std::endl
                 << std::endl
-
+                << "[140] NCC TO CC (READ)          = " << "0" << std::endl
+                << "[141] NCC TO CC (WRITE)         = " << "0" << std::endl
+                << std::endl
+                << "[150] LOCAL GETM                = " << m_cpt_getm_local << std::endl
+                << "[151] REMOTE GETM               = " << m_cpt_getm_remote << std::endl
+                << "[152] GETM COST (FLITS * DIST)  = " << m_cpt_getm_cost << std::endl
+                << std::endl
+                << "[160] LOCAL INVAL RO            = " << m_cpt_inval_ro_local << std::endl
+                << "[161] REMOTE INVAL RO           = " << m_cpt_inval_ro_remote << std::endl
+                << "[162] INVAL RO COST             = " << m_cpt_inval_ro_cost << std::endl
+                << std::endl;
+
+#if 0
                 << "[050] LOCAL GETM MISS           = " << m_cpt_getm_miss_local << std::endl
                 << "[051] REMOTE GETM MISS          = " << m_cpt_getm_miss_remote << std::endl
@@ -1047,6 +977,4 @@
                 << "[053] REMOTE GETM HIT           = " << m_cpt_getm_hit_remote << std::endl
                 << "[054] GETM COST (FLITS * DIST)  = " << m_cpt_getm_cost << std::endl
-                << std::endl
-                << "[055] CLEANUP WITH DATA         = " << m_cpt_cleanup_with_data << std::endl
                 << std::endl
                 << "[056] MULTI_ACK_MISS            = " << m_cpt_multi_ack_miss << std::endl
